/*
 * Copyright (C) Sergey P. Derevyago, 2003-2004.
 *
 * Permission to copy, use, modify, sell and distribute this software is granted
 * provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied warranty, and
 * with no claim as to its suitability for any purpose.
 *
 */

/** @file
 *   AutoFILE.
 */

#ifndef __AUTOFILE_HPP__
 #define __AUTOFILE_HPP__

#include <stdio.h>

/**
 *       FILE.
 */
class AutoFILE {
      /**    */
      FILE* f;

      /**   */
      AutoFILE(const AutoFILE&);
      /**   */
      AutoFILE& operator=(const AutoFILE&);

 public:
      /**
       *     .
       */
      explicit AutoFILE(FILE* f_) : f(f_) {}

      /**
       *   .
       */
      FILE* get() const { return f; }

      /**
       *  ,     .
       */
      ~AutoFILE() { if (f) fclose(f); }
};

#endif
