/*
 * Copyright (C) Sergey P. Derevyago, 2003-2004.
 *
 * Permission to copy, use, modify, sell and distribute this software is granted
 * provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied warranty, and
 * with no claim as to its suitability for any purpose.
 *
 */

/** @file
 *  -,  ,   
 * .   ftext   .
 */

#include <stdio.h>
#include <vector>
#include "cexception.hpp"

using namespace std;

/** -  CException     */
class ExampleCException : public CException {
 protected:
      ExampleCException(const FileLine& loc, const std::string& msg,
        sh_ptr<CException> nest) : CException(loc, msg, nest) {}

 public:
      friend sh_ptr<CException> newExampleCException(const FileLine& loc,
        const std::string& msg, sh_ptr<CException> nest=sh_ptr<CException>());

      virtual std::string getClassName() const { return "ExampleCException"; }
};

inline sh_ptr<CException> newExampleCException(const CException::FileLine& loc,
  const std::string& msg, sh_ptr<CException> nest)
{
#ifndef DERS_RETHROW_BUG
 //    
 return sh_ptr<CException>(new ExampleCException(loc, msg, nest));
#else
 //   ,   
 // 
 //         
 // CException::current,   toCException()  
 //  ( )    
 return CException::current=sh_ptr<CException>(new ExampleCException(loc, msg,
   nest));
#endif 
}

int i;

void g()
{
 //    try   ""  
 //    ,     
 // ,     CException,     
 // 
 try {
     switch (i) {
 //   ExampleCException    newExampleCException()
 //  _FLINE_   CException::FileLine(__FILE__, __LINE__)
            case 1: throw newExampleCException(_FLINE_, "Hello from g()");
 //   std::out_of_range     
            case 2: {
                 vector<int> v;
                 v.at(0);
            }
 //     int
            case 3: throw 3;
     }
 }
 //   catch,   
 // ..   (...),    , 
 //  ,  toCException()  ,  
 //       sh_ptr<CException>
 //        nested 
 // ,       g()
 catch (...) {
       throw newCException(_FLINE_, "Problems in g()", toCException(_FLINE_));
 }
}

void f()
{
 try { g(); }
 // ,          f()
 catch (...) {
       throw newCException(_FLINE_, "Problems in f()", toCException(_FLINE_));
 }
}

int main()
{
 for (i=1; i<=4; i++) {
     try {
         if (i<4) f();
 //  " "    ,  
 //   toCException()    CException::FileLine
         else throw 4;
     }
 //      toStringAll()  
 //      
     catch (...) {
           printf("\tException #%d:\n%s", i,
             toCException(_FLINE_)->toStringAll().c_str());
     }
 }
}
