/*
 * Copyright (C) Sergey P. Derevyago, 2003-2004.
 *
 * Permission to copy, use, modify, sell and distribute this software is granted
 * provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied warranty, and
 * with no claim as to its suitability for any purpose.
 *
 */

/** @file
 *   NameMatcher.
 */

#ifndef __NAMEMATCHER_HPP__
 #define __NAMEMATCHER_HPP__

#include "cexception.hpp"

/**
 *         .
 * ,       ,  
 *       .
 */
class NameMatcher {
 public:
      /**
       *       ,  
       *   .  true,    
       * .  CException    .
       */
      virtual bool match(const std::string& fileName)=0;

      /**
       *   .
       */
      virtual ~NameMatcher() {}

 private:
      /**   */
      NameMatcher& operator=(const NameMatcher&);
};

/**
 *  .
 */
namespace Factory {

 /**
  *     ,   NameMatcher. 
  *     CException.
  */
 sh_ptr<NameMatcher> newNameMatcher(const std::string& mask);

}

#endif
