/*
 * Copyright (C) Sergey P. Derevyago, 2003-2004.
 *
 * Permission to copy, use, modify, sell and distribute this software is granted
 * provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied warranty, and
 * with no claim as to its suitability for any purpose.
 *
 */

/** @file
 *  ,   pubsub.hpp.
 */

#include "pubsub.hpp"

bool PubSub_private::PubImpl::subscribe(void* sub)
{
 if (isSubscribed(sub)) return 0;

 subs.push_back(sub);
 return 1;
}

bool PubSub_private::PubImpl::unsubscribe(void* sub)
{
 for (list_type::iterator it=subs.begin(), end=subs.end(); it!=end; ++it) {
     if (*it==sub) {
        subs.erase(it);
        return 1;
     }
 }

 return 0;
}

bool PubSub_private::PubImpl::isSubscribed(void* sub) const
{
 for (list_type::const_iterator cit=subs.begin(), cend=subs.end(); cit!=cend;
      ++cit) {
     if (*cit==sub) return 1;
 }

 return 0;
}
