/*
 * Copyright (C) Sergey P. Derevyago, 2003-2004.
 *
 * Permission to copy, use, modify, sell and distribute this software is granted
 * provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied warranty, and
 * with no claim as to its suitability for any purpose.
 *
 */

/** @file
 *  ,   stringbuf.hpp.
 */

#include "stringbuf.hpp"
#include <stdio.h>

using namespace std;

//      
#define PLUS_BODY(form)       \
 char buf[25];                \
 sprintf(buf, "%" form, val); \
 tmps.add(buf);               \
 ptrs.add(&tmps.tail->val);   \
 return *this;

StringBuf& StringBuf::operator+(int val)
{
 PLUS_BODY("d")
}

StringBuf& StringBuf::operator+(unsigned int val)
{
 PLUS_BODY("u")
}

StringBuf& StringBuf::operator+(long val)
{
 PLUS_BODY("ld")
}

StringBuf& StringBuf::operator+(unsigned long val)
{
 PLUS_BODY("lu")
}

#undef PLUS_BODY

StringBuf::operator std::string() const
{
 typedef StringBuf_private::Node<const string*> node_type;
 
 int len=0;
 for (node_type* ptr=ptrs.head; ptr; ptr=ptr->next) len+=ptr->val->size();
 
 string ret;
 ret.reserve(len);

 for (node_type* ptr=ptrs.head; ptr; ptr=ptr->next) ret.append(*ptr->val);
 return ret;
}
