/*
 * Copyright (C) Sergey P. Derevyago, 2003-2004.
 *
 * Permission to copy, use, modify, sell and distribute this software is granted
 * provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied warranty, and
 * with no claim as to its suitability for any purpose.
 *
 */

/** @file
 *   TextFinder.
 */

#ifndef __TEXTFINDER_HPP__
 #define __TEXTFINDER_HPP__

#include "cexception.hpp"

/**
 *         
 *  . ,       ,
 *         .
 */
class TextFinder {
 public:
      /**
       *        . 
       * true,      .  CException  
       *  .
       */
      virtual bool findIn(const std::string& line)=0;

      /**
       *   .
       */
      virtual ~TextFinder() {}

 private:
      /**   */
      TextFinder& operator=(const TextFinder&);
};

/**
 *  .
 */
namespace Factory {

 /**
  *     ,   TextFinder. 
  *     CException.
  */
 sh_ptr<TextFinder> newTextFinder(const std::string& text);

}

#endif
