/*
 * Copyright (C) Sergey P. Derevyago, 2003-2004.
 *
 * Permission to copy, use, modify, sell and distribute this software is granted
 * provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied warranty, and
 * with no claim as to its suitability for any purpose.
 *
 */

/** @file
 *   TextFinder.
 */

#include "textfinder.hpp"

using namespace std;

namespace {

 /**
  * -  TextFinder,   
  * .
  */
 class TextFinderImpl : public TextFinder {
       /**      */
       string text;

       /**
        *     text   .
        */
       virtual bool findIn(const std::string& line);

  public:
       /**
        *     .
        */
       TextFinderImpl(const std::string& text_) : text(text_) {}
 };

 bool TextFinderImpl::findIn(const std::string& line)
 {
  return line.find(text)!=string::npos;
 }

}

sh_ptr<TextFinder> Factory::newTextFinder(const std::string& mask)
{
 try { return sh_ptr<TextFinder>(new TextFinderImpl(mask)); }
 catch (...) {
       throw newCException(_FLINE_, "Can't create TextFinderImpl object",
         toCException(_FLINE_));
 }
}
